
_InitTimer1:

;timer.c,82 :: 		void InitTimer1(){
;timer.c,83 :: 		T1CON         = 0x21;
	MOVLW      33
	MOVWF      T1CON+0
;timer.c,84 :: 		TMR1IF_bit         = 0;
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;timer.c,85 :: 		TMR1H         = 0x3C;
	MOVLW      60
	MOVWF      TMR1H+0
;timer.c,86 :: 		TMR1L         = 0xB0;
	MOVLW      176
	MOVWF      TMR1L+0
;timer.c,87 :: 		TMR1IE_bit         = 1;
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;timer.c,88 :: 		INTCON         = 0xC0;
	MOVLW      192
	MOVWF      INTCON+0
;timer.c,89 :: 		}
L_end_InitTimer1:
	RETURN
; end of _InitTimer1

_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;timer.c,92 :: 		void interrupt(){
;timer.c,93 :: 		if (TMR1IF_bit){
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_interrupt0
;timer.c,94 :: 		TMR1IF_bit = 0;
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;timer.c,95 :: 		TMR1H         = 0x3C;
	MOVLW      60
	MOVWF      TMR1H+0
;timer.c,96 :: 		TMR1L         = 0xB0;
	MOVLW      176
	MOVWF      TMR1L+0
;timer.c,98 :: 		if(count_flag){                                                         // only count down while flag is set
	MOVF       _count_flag+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt1
;timer.c,99 :: 		fraction--;                                                         // count down
	DECF       _fraction+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _fraction+0
;timer.c,100 :: 		if(fraction | seconds_units | seconds_tens | minutes_units | minutes_tens | hours){  // check for non-zero
	MOVF       _seconds_units+0, 0
	IORWF      _fraction+0, 0
	MOVWF      R0+0
	MOVF       _seconds_tens+0, 0
	IORWF      R0+0, 1
	MOVF       _minutes_units+0, 0
	IORWF      R0+0, 1
	MOVF       _minutes_tens+0, 0
	IORWF      R0+0, 1
	MOVF       _hours+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt2
;timer.c,101 :: 		if(fraction < 0){                                               // must have wrapped around
	MOVLW      128
	XORWF      _fraction+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt3
;timer.c,102 :: 		fraction = 4;
	MOVLW      4
	MOVWF      _fraction+0
;timer.c,103 :: 		Relay_3 = ~Relay_3;                                         // toggle RA2 every second
	MOVLW
	XORWF      RA2_bit+0, 1
;timer.c,105 :: 		if(time_choice == 1){                                       // 30 minute selection
	MOVF       _time_choice+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt4
;timer.c,106 :: 		led_GREEN = ~led_GREEN;                                 // flash green LED RA4
	MOVLW
	XORWF      RA4_bit+0, 1
;timer.c,107 :: 		}
L_interrupt4:
;timer.c,108 :: 		if(time_choice == 2){                                       // 2 hour selection
	MOVF       _time_choice+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt5
;timer.c,109 :: 		led_YELLOW = ~led_YELLOW;                               // flash yellow LED RA5
	MOVLW
	XORWF      RA5_bit+0, 1
;timer.c,110 :: 		}
L_interrupt5:
;timer.c,111 :: 		if(time_choice == 3){                                       // 5 hour selection
	MOVF       _time_choice+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt6
;timer.c,112 :: 		led_BLUE = ~led_BLUE;                                   // flash blue LED RB0
	MOVLW
	XORWF      RB0_bit+0, 1
;timer.c,113 :: 		}
L_interrupt6:
;timer.c,114 :: 		toggle_flag = ~toggle_flag;                                 // toggle this flag every second for LCD colon flash
	COMF       _toggle_flag+0, 1
;timer.c,116 :: 		update_flag = 1;                                            // time to display new number
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,117 :: 		seconds_units--;
	DECF       _seconds_units+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _seconds_units+0
;timer.c,118 :: 		if(seconds_units < 0){                                      // must have wrapped around
	MOVLW      128
	XORWF      _seconds_units+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt7
;timer.c,119 :: 		seconds_units = 9;
	MOVLW      9
	MOVWF      _seconds_units+0
;timer.c,121 :: 		seconds_tens--;
	DECF       _seconds_tens+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _seconds_tens+0
;timer.c,122 :: 		if(seconds_tens < 0){                                   // must have wrapped around
	MOVLW      128
	XORWF      _seconds_tens+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt8
;timer.c,123 :: 		seconds_tens = 5;
	MOVLW      5
	MOVWF      _seconds_tens+0
;timer.c,125 :: 		minutes_units--;
	DECF       _minutes_units+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _minutes_units+0
;timer.c,126 :: 		if(minutes_units < 0){                              // must have wrapped around
	MOVLW      128
	XORWF      _minutes_units+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt9
;timer.c,127 :: 		minutes_units = 9;
	MOVLW      9
	MOVWF      _minutes_units+0
;timer.c,129 :: 		minutes_tens--;
	DECF       _minutes_tens+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _minutes_tens+0
;timer.c,130 :: 		if(minutes_tens < 0){                           // must have wrapped around
	MOVLW      128
	XORWF      _minutes_tens+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt10
;timer.c,131 :: 		minutes_tens = 5;
	MOVLW      5
	MOVWF      _minutes_tens+0
;timer.c,132 :: 		hours--;                                    // no further check as hours always less than 9
	DECF       _hours+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _hours+0
;timer.c,133 :: 		}
L_interrupt10:
;timer.c,134 :: 		}
L_interrupt9:
;timer.c,135 :: 		}
L_interrupt8:
;timer.c,136 :: 		}
L_interrupt7:
;timer.c,137 :: 		}
L_interrupt3:
;timer.c,138 :: 		}
	GOTO       L_interrupt11
L_interrupt2:
;timer.c,140 :: 		count_flag = 0;                                                 // prevent going below zero
	CLRF       _count_flag+0
;timer.c,141 :: 		zero_flag = 1;                                                  // so indicate zero reached
	MOVLW      1
	MOVWF      _zero_flag+0
;timer.c,142 :: 		}
L_interrupt11:
;timer.c,143 :: 		}
L_interrupt1:
;timer.c,144 :: 		}
L_interrupt0:
;timer.c,145 :: 		}
L_end_interrupt:
L__interrupt44:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_debounce:

;timer.c,148 :: 		void debounce(){
;timer.c,149 :: 		Delay_ms(250);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      69
	MOVWF      R12+0
	MOVLW      169
	MOVWF      R13+0
L_debounce12:
	DECFSZ     R13+0, 1
	GOTO       L_debounce12
	DECFSZ     R12+0, 1
	GOTO       L_debounce12
	DECFSZ     R11+0, 1
	GOTO       L_debounce12
	NOP
	NOP
;timer.c,150 :: 		}
L_end_debounce:
	RETURN
; end of _debounce

_leds_off:

;timer.c,153 :: 		void leds_off(){
;timer.c,154 :: 		led_BLUE = 0;                                                               // RB0
	BCF        RB0_bit+0, BitPos(RB0_bit+0)
;timer.c,155 :: 		led_RED = 0;                                                                // RC5
	BCF        RC5_bit+0, BitPos(RC5_bit+0)
;timer.c,156 :: 		led_GREEN = 0;                                                              // RA4
	BCF        RA4_bit+0, BitPos(RA4_bit+0)
;timer.c,157 :: 		led_YELLOW = 0;                                                             // RA5
	BCF        RA5_bit+0, BitPos(RA5_bit+0)
;timer.c,158 :: 		}
L_end_leds_off:
	RETURN
; end of _leds_off

_Play_Sound:

;timer.c,161 :: 		void Play_Sound(){
;timer.c,164 :: 		for(buzz_count = 0; buzz_count < 1000; buzz_count++){                       // 1000 times 1 ms gives 1 second buzz
	CLRF       R1+0
	CLRF       R1+1
L_Play_Sound13:
	MOVLW      3
	SUBWF      R1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Play_Sound48
	MOVLW      232
	SUBWF      R1+0, 0
L__Play_Sound48:
	BTFSC      STATUS+0, 0
	GOTO       L_Play_Sound14
;timer.c,165 :: 		Buzzer = 1;
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
;timer.c,166 :: 		Delay_us(500);                                                          // adjust on/off times for preferred volume and frequency
	MOVLW      166
	MOVWF      R13+0
L_Play_Sound16:
	DECFSZ     R13+0, 1
	GOTO       L_Play_Sound16
	NOP
;timer.c,167 :: 		Buzzer = 0;
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
;timer.c,168 :: 		Delay_us(500);                                                          // off for remainder of 1ms to give 1kHz
	MOVLW      166
	MOVWF      R13+0
L_Play_Sound17:
	DECFSZ     R13+0, 1
	GOTO       L_Play_Sound17
	NOP
;timer.c,164 :: 		for(buzz_count = 0; buzz_count < 1000; buzz_count++){                       // 1000 times 1 ms gives 1 second buzz
	INCF       R1+0, 1
	BTFSC      STATUS+0, 2
	INCF       R1+1, 1
;timer.c,169 :: 		}
	GOTO       L_Play_Sound13
L_Play_Sound14:
;timer.c,170 :: 		}
L_end_Play_Sound:
	RETURN
; end of _Play_Sound

_relays_on:

;timer.c,173 :: 		void relays_on(){
;timer.c,174 :: 		Relay_1 = 1;
	BSF        RA0_bit+0, BitPos(RA0_bit+0)
;timer.c,175 :: 		Relay_2 = 1;
	BSF        RA1_bit+0, BitPos(RA1_bit+0)
;timer.c,176 :: 		Relay_3 = 1;
	BSF        RA2_bit+0, BitPos(RA2_bit+0)
;timer.c,177 :: 		Lcd_Out(1,1,Message3);                                                      // "Timer ON: HH:MM"
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _Message3+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;timer.c,178 :: 		}
L_end_relays_on:
	RETURN
; end of _relays_on

_time_zero:

;timer.c,181 :: 		void time_zero(){
;timer.c,183 :: 		leds_off();                                                                 // all LEDs off
	CALL       _leds_off+0
;timer.c,184 :: 		count_flag = 0;                                                             // stop the countdown
	CLRF       _count_flag+0
;timer.c,185 :: 		fraction = 0;                                                               // set all time variables to zero
	CLRF       _fraction+0
;timer.c,186 :: 		seconds_units = 0;
	CLRF       _seconds_units+0
;timer.c,187 :: 		seconds_tens = 0;
	CLRF       _seconds_tens+0
;timer.c,188 :: 		minutes_units = 0;
	CLRF       _minutes_units+0
;timer.c,189 :: 		minutes_tens = 0;
	CLRF       _minutes_tens+0
;timer.c,190 :: 		hours = 0;
	CLRF       _hours+0
;timer.c,191 :: 		zero_flag = 0;
	CLRF       _zero_flag+0
;timer.c,192 :: 		Relay_1 = 0;                                                                // RA0
	BCF        RA0_bit+0, BitPos(RA0_bit+0)
;timer.c,193 :: 		Relay_2 = 0;                                                                // RA1
	BCF        RA1_bit+0, BitPos(RA1_bit+0)
;timer.c,194 :: 		Relay_3 = 0;                                                                // RA2
	BCF        RA2_bit+0, BitPos(RA2_bit+0)
;timer.c,195 :: 		leds_off();                                                                 // all LEDs off
	CALL       _leds_off+0
;timer.c,196 :: 		Lcd_Out(1,1,Message2);                                                      // "Timer OFF     "
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _Message2+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;timer.c,197 :: 		Play_Sound();                                                               // activate the buzzer
	CALL       _Play_Sound+0
;timer.c,198 :: 		Lcd_Out(1,1,Message4);                                                      // "Set Time   "
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _Message4+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;timer.c,199 :: 		time_choice = 0;                                                            // 0 for no time selected
	CLRF       _time_choice+0
;timer.c,200 :: 		}
L_end_time_zero:
	RETURN
; end of _time_zero

_main:

;timer.c,202 :: 		void main() {
;timer.c,204 :: 		count_flag = 0;                                                             // no count down to start with
	CLRF       _count_flag+0
;timer.c,205 :: 		ANSEL = 0x00;                                                               // all digital
	CLRF       ANSEL+0
;timer.c,206 :: 		ANSELH = 0x00;                                                              // all digital
	CLRF       ANSELH+0
;timer.c,207 :: 		CM1CON0 = 7;                                                                // Disable Comparators
	MOVLW      7
	MOVWF      CM1CON0+0
;timer.c,208 :: 		TRISA = 0b11001000;                                                         // TRISA
	MOVLW      200
	MOVWF      TRISA+0
;timer.c,209 :: 		TRISB = 0b00000000;                                                         // TRISB
	CLRF       TRISB+0
;timer.c,210 :: 		TRISC = 0b11001111;                                                         // TRISC
	MOVLW      207
	MOVWF      TRISC+0
;timer.c,211 :: 		Relay_1 = 0;                                                                // RA0
	BCF        RA0_bit+0, BitPos(RA0_bit+0)
;timer.c,212 :: 		Relay_2 = 0;                                                                // RA1
	BCF        RA1_bit+0, BitPos(RA1_bit+0)
;timer.c,213 :: 		Relay_3 = 0;                                                                // RA2
	BCF        RA2_bit+0, BitPos(RA2_bit+0)
;timer.c,214 :: 		Lcd_Init();                                                                 // Initialize LCD
	CALL       _Lcd_Init+0
;timer.c,216 :: 		Lcd_Cmd(_LCD_CLEAR);                                                        // Clear LCD
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;timer.c,217 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);                                                   // turn off flashing cursor
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;timer.c,218 :: 		Lcd_Out(1,1,Message1);                                                      // introducton text
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _Message1+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;timer.c,219 :: 		Delay_ms(3000);                                                             // allow time for intro text to be read by user
	MOVLW      16
	MOVWF      R11+0
	MOVLW      57
	MOVWF      R12+0
	MOVLW      13
	MOVWF      R13+0
L_main18:
	DECFSZ     R13+0, 1
	GOTO       L_main18
	DECFSZ     R12+0, 1
	GOTO       L_main18
	DECFSZ     R11+0, 1
	GOTO       L_main18
	NOP
	NOP
;timer.c,220 :: 		Lcd_Out(1,1,Message2);                                                      // "Timer OFF"
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _Message2+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;timer.c,221 :: 		Delay_ms(2000);                                                             // allow time for intro text to be read by user
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main19:
	DECFSZ     R13+0, 1
	GOTO       L_main19
	DECFSZ     R12+0, 1
	GOTO       L_main19
	DECFSZ     R11+0, 1
	GOTO       L_main19
	NOP
	NOP
;timer.c,222 :: 		Lcd_Out(2,1,Message5);                                                      // "Time Left: "
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _Message5+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;timer.c,223 :: 		OPTION_REG = 0x80 ;                                                         // bit7 Enable PORTB Pull UP
	MOVLW      128
	MOVWF      OPTION_REG+0
;timer.c,225 :: 		time_zero();                                                                // set time to zero and stop counting
	CALL       _time_zero+0
;timer.c,227 :: 		InitTimer1();                                                               // start 100ms timer Interrupt running
	CALL       _InitTimer1+0
;timer.c,228 :: 		update_flag = 1;                                                            // show initial value
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,230 :: 		while(1){                                                                   // main loop
L_main20:
;timer.c,232 :: 		while(!update_flag){                                                    // wait for interrupt routine to indicate display update needed
L_main22:
	MOVF       _update_flag+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_main23
;timer.c,233 :: 		if(!Start_Stop_Button){                                             // and while waiting - check buttons
	BTFSC      RC0_bit+0, BitPos(RC0_bit+0)
	GOTO       L_main24
;timer.c,234 :: 		if(count_flag){                                                 // are we counting?
	MOVF       _count_flag+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main25
;timer.c,235 :: 		time_zero();                                                // reset if counting
	CALL       _time_zero+0
;timer.c,236 :: 		}
	GOTO       L_main26
L_main25:
;timer.c,238 :: 		count_flag = 1;                                             // then start counting
	MOVLW      1
	MOVWF      _count_flag+0
;timer.c,239 :: 		led_RED = 1;                                                // RC5 red LED on while timer is counting down
	BSF        RC5_bit+0, BitPos(RC5_bit+0)
;timer.c,240 :: 		relays_on();                                                // turn on all relays
	CALL       _relays_on+0
;timer.c,241 :: 		}
L_main26:
;timer.c,242 :: 		debounce();                                                     // prevent multiple triggers
	CALL       _debounce+0
;timer.c,243 :: 		while(!Start_Stop_Button);                                      // wait for button release
L_main27:
	BTFSC      RC0_bit+0, BitPos(RC0_bit+0)
	GOTO       L_main28
	GOTO       L_main27
L_main28:
;timer.c,244 :: 		update_flag = 1;                                                // show new value
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,245 :: 		}
L_main24:
;timer.c,246 :: 		if(!Min30_Button){                                                  // if RC1 goes low
	BTFSC      RC1_bit+0, BitPos(RC1_bit+0)
	GOTO       L_main29
;timer.c,247 :: 		leds_off();                                                     // all lEDs off
	CALL       _leds_off+0
;timer.c,248 :: 		led_GREEN = 1;
	BSF        RA4_bit+0, BitPos(RA4_bit+0)
;timer.c,249 :: 		fraction = 0;
	CLRF       _fraction+0
;timer.c,250 :: 		seconds_units = 0;
	CLRF       _seconds_units+0
;timer.c,251 :: 		seconds_tens = 0;                                               // change to zero for final project
	CLRF       _seconds_tens+0
;timer.c,252 :: 		minutes_units = 0;
	CLRF       _minutes_units+0
;timer.c,253 :: 		minutes_tens = 3;                                               // change to 3 for final project
	MOVLW      3
	MOVWF      _minutes_tens+0
;timer.c,254 :: 		hours = 0;
	CLRF       _hours+0
;timer.c,255 :: 		debounce();                                                     // prevent multiple triggers
	CALL       _debounce+0
;timer.c,256 :: 		while(!Min30_Button);                                           // wait for button release
L_main30:
	BTFSC      RC1_bit+0, BitPos(RC1_bit+0)
	GOTO       L_main31
	GOTO       L_main30
L_main31:
;timer.c,257 :: 		update_flag = 1;                                                // show new value
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,258 :: 		time_choice = 1;                                                // 1 for 30 minutes selected
	MOVLW      1
	MOVWF      _time_choice+0
;timer.c,259 :: 		}
L_main29:
;timer.c,260 :: 		if(!Hour2_Button){                                                  // if RC2 goes low
	BTFSC      RC2_bit+0, BitPos(RC2_bit+0)
	GOTO       L_main32
;timer.c,261 :: 		leds_off();                                                     // all lEDs off
	CALL       _leds_off+0
;timer.c,262 :: 		led_YELLOW = 1;                                                 // RA5
	BSF        RA5_bit+0, BitPos(RA5_bit+0)
;timer.c,263 :: 		fraction = 0;
	CLRF       _fraction+0
;timer.c,264 :: 		seconds_units = 0;
	CLRF       _seconds_units+0
;timer.c,265 :: 		seconds_tens = 0;
	CLRF       _seconds_tens+0
;timer.c,266 :: 		minutes_units = 0;
	CLRF       _minutes_units+0
;timer.c,267 :: 		minutes_tens = 0;
	CLRF       _minutes_tens+0
;timer.c,268 :: 		hours = 2;
	MOVLW      2
	MOVWF      _hours+0
;timer.c,269 :: 		debounce();                                                     // prevent multiple triggers
	CALL       _debounce+0
;timer.c,270 :: 		while(!Hour2_Button);                                           // wait for button release
L_main33:
	BTFSC      RC2_bit+0, BitPos(RC2_bit+0)
	GOTO       L_main34
	GOTO       L_main33
L_main34:
;timer.c,271 :: 		update_flag = 1;                                                // show new value
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,272 :: 		time_choice = 2;                                                // 2 for 2 hours selected
	MOVLW      2
	MOVWF      _time_choice+0
;timer.c,273 :: 		}
L_main32:
;timer.c,274 :: 		if(!Hour5_Button){                                                  // if RC2 goes low
	BTFSC      RA3_bit+0, BitPos(RA3_bit+0)
	GOTO       L_main35
;timer.c,275 :: 		leds_off();                                                     // all lEDs off
	CALL       _leds_off+0
;timer.c,276 :: 		led_BLUE = 1;                                                   // RB0
	BSF        RB0_bit+0, BitPos(RB0_bit+0)
;timer.c,277 :: 		fraction = 0;
	CLRF       _fraction+0
;timer.c,278 :: 		seconds_units = 0;
	CLRF       _seconds_units+0
;timer.c,279 :: 		seconds_tens = 0;
	CLRF       _seconds_tens+0
;timer.c,280 :: 		minutes_units = 0;
	CLRF       _minutes_units+0
;timer.c,281 :: 		minutes_tens = 0;
	CLRF       _minutes_tens+0
;timer.c,282 :: 		hours = 5;
	MOVLW      5
	MOVWF      _hours+0
;timer.c,283 :: 		debounce();                                                     // prevent multiple triggers
	CALL       _debounce+0
;timer.c,284 :: 		while(!Hour5_Button);                                           // wait for button release
L_main36:
	BTFSC      RA3_bit+0, BitPos(RA3_bit+0)
	GOTO       L_main37
	GOTO       L_main36
L_main37:
;timer.c,285 :: 		update_flag = 1;                                                // show new value
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,286 :: 		time_choice = 3;                                                // show that 5 hour selection was made
	MOVLW      3
	MOVWF      _time_choice+0
;timer.c,287 :: 		}
L_main35:
;timer.c,288 :: 		if(Oven_OFF){                                                       // if RC7 goes high
	BTFSS      RC7_bit+0, BitPos(RC7_bit+0)
	GOTO       L_main38
;timer.c,289 :: 		time_zero();                                                    // set time to zero and stop counting
	CALL       _time_zero+0
;timer.c,290 :: 		update_flag = 1;                                                // show new value
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,291 :: 		debounce();                                                     // prevent multiple triggers
	CALL       _debounce+0
;timer.c,292 :: 		}
L_main38:
;timer.c,293 :: 		if(zero_flag){                                                      // countdown just reached zero
	MOVF       _zero_flag+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main39
;timer.c,294 :: 		update_flag = 1;                                                // show new value
	MOVLW      1
	MOVWF      _update_flag+0
;timer.c,295 :: 		time_zero();                                                    // set time to zero and stop counting
	CALL       _time_zero+0
;timer.c,296 :: 		}
L_main39:
;timer.c,297 :: 		if(toggle_flag){                                                    // flash the colon on display
	MOVF       _toggle_flag+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main40
;timer.c,298 :: 		Lcd_Chr(2,13,' ');
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      13
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      32
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;timer.c,299 :: 		}
	GOTO       L_main41
L_main40:
;timer.c,301 :: 		Lcd_Chr(2,13,':');
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      13
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      58
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;timer.c,302 :: 		}
L_main41:
;timer.c,304 :: 		}
	GOTO       L_main22
L_main23:
;timer.c,310 :: 		Lcd_Chr(2, 15, minutes_units + 48);                                     // print minutes
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      15
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      48
	ADDWF      _minutes_units+0, 0
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;timer.c,311 :: 		Lcd_Chr(2, 14, minutes_tens + 48);                                      // print minutes
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      14
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      48
	ADDWF      _minutes_tens+0, 0
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;timer.c,312 :: 		Lcd_Chr(2, 13, ':');                                                    // print colon
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      13
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      58
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;timer.c,313 :: 		Lcd_Chr(2, 12, hours + 48);                                             // print hours
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      12
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      48
	ADDWF      _hours+0, 0
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;timer.c,314 :: 		update_flag = 0;                                                        // prevent multiple printouts
	CLRF       _update_flag+0
;timer.c,315 :: 		}
	GOTO       L_main20
;timer.c,316 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
