// code found on forum - re-written 23 July 2020

// written by amateur coder - use at own risk
// author accepts no resposibility for anything, anywhere, ever

// 23 July It should work like this:
// done                      It has 3 set time buttons: 30 min , 2 hour and 5 hour
// done                      start/Stop button
// done                      When the device is on it will display some messages.
// done                      Timer OFF
// done                      Set Time : 00:00
// done                      When I press 30 min button: green_led is ON
// done                      Message: Set time 00;30
// done                      When i press the Start/Stop button: Start_Stop led is ON
// done                      Message: Timer is ON

// done - So if I want to abort time maybe change so I want to press the Start/Stop again and it should reset the counter to zero
//                  and OFF the green_led and Start/Stop led.

// done - colon flashes, not cursor         3)Blink on LCD display needs to work when timer is ON
// done                     4)led_RED is ON when Start_Stop button is pressed --Fixed
// done                     5)Led_Gr/Yel or Blue need to Blink every sec when ON (Start_Stop) is pressed

// LCD module connections
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;

sbit Relay_1 at RA0_bit;                                                        // wonder what Relay_1 does ????
sbit Relay_2 at RA1_bit;                                                        // wonder what Relay_2 does ????
sbit Relay_3 at RA2_bit;                                                        // wonder what Relay_3 does ????

//Outputs:LEDs
sbit led_RED at RC5_bit;                                                        // led Red for Start/Stop of timers
sbit led_GREEN at RA4_bit;                                                      // led Green for 30 mins
sbit led_YELLOW at RA5_bit;                                                     // led Yellow for 3 hrs
sbit led_BLUE at RB0_bit;                                                       // led Blue for 8 hrs

//Outputs: Buzzer
sbit Buzzer at RB1_bit; //Buzzer

//Inputs: Tact Switches and external signal
sbit Start_Stop_Button at RC0_bit;                                              // Starts or Stops Timer Select
sbit Min30_Button at RC1_bit;                                                   // Set 30 min timer
sbit Hour2_Button at RC2_bit;                                                   // Set 3 hours timer
sbit Hour5_Button at RA3_bit;                                                   // Set 5 hours timer
sbit Oven_OFF at RC7_bit;                                                       // Close oven and all 3Relays

// Messages
char Message1[]="30min-5hr:Timer OFF";
char Message2[]="Timer OFF  H:MM";
char Message3[]="Timer ON:";
char Message4[]="Set Time:";
char Message5[]="Time Left: 0:00";

// global count-down store
volatile signed char fraction;                                                  // 5ths of a second
volatile signed char seconds_units;                                             // volatile to warn compiler that value may change in interrupt
volatile signed char seconds_tens;
volatile signed char minutes_units;
volatile signed char minutes_tens;
volatile signed char hours;

// other global variables
unsigned char digit[5] = "0:00";
volatile unsigned char update_flag;                                             // set to show display update needed
volatile unsigned char count_flag;                                              // set when counting down is wanted
volatile unsigned char zero_flag;                                               // set when zero count is reached
unsigned char time_choice = 0;                                                  // selected time, 0=no selection, 1=30 min, 2=2 hours, 3= 5 hours
unsigned char toggle_flag = 0;                                                  // togle every second for flashing colon

//Timer1 Initialise Prescaler 1:2; TMR1 Preload = 15536; Actual Interrupt Time : 200 ms
void InitTimer1(){
    T1CON         = 0x21;
    TMR1IF_bit         = 0;
    TMR1H         = 0x3C;
    TMR1L         = 0xB0;
    TMR1IE_bit         = 1;
    INTCON         = 0xC0;
}

// interrupt every 200 milliseconds
void interrupt(){
    if (TMR1IF_bit){
        TMR1IF_bit = 0;
        TMR1H         = 0x3C;
        TMR1L         = 0xB0;

        if(count_flag){                                                         // only count down while flag is set
            fraction--;                                                         // count down
            if(fraction | seconds_units | seconds_tens | minutes_units | minutes_tens | hours){  // check for non-zero
                if(fraction < 0){                                               // must have wrapped around
                    fraction = 4;
                    Relay_3 = ~Relay_3;                                         // toggle RA2 every second
                    
                    if(time_choice == 1){                                       // 30 minute selection
                        led_GREEN = ~led_GREEN;                                 // flash green LED RA4
                    }
                    if(time_choice == 2){                                       // 2 hour selection
                        led_YELLOW = ~led_YELLOW;                               // flash yellow LED RA5
                    }
                    if(time_choice == 3){                                       // 5 hour selection
                        led_BLUE = ~led_BLUE;                                   // flash blue LED RB0
                    }
                    toggle_flag = ~toggle_flag;                                 // toggle this flag every second for LCD colon flash

                    update_flag = 1;                                            // time to display new number
                    seconds_units--;
                    if(seconds_units < 0){                                      // must have wrapped around
                        seconds_units = 9;

                        seconds_tens--;
                        if(seconds_tens < 0){                                   // must have wrapped around
                            seconds_tens = 5;

                            minutes_units--;
                            if(minutes_units < 0){                              // must have wrapped around
                                minutes_units = 9;

                                minutes_tens--;
                                if(minutes_tens < 0){                           // must have wrapped around
                                    minutes_tens = 5;
                                    hours--;                                    // no further check as hours always less than 9
                                }
                            }
                        }
                    }
                }
            }
            else{                                                               // counter is zero
                count_flag = 0;                                                 // prevent going below zero
                zero_flag = 1;                                                  // so indicate zero reached
            }
        }
    }
}

// button de-douce delay
void debounce(){
    Delay_ms(250);
}

// all LEDs off
void leds_off(){
    led_BLUE = 0;                                                               // RB0
    led_RED = 0;                                                                // RC5
    led_GREEN = 0;                                                              // RA4
    led_YELLOW = 0;                                                             // RA5
}

// Buzzer sound - piezo Buzzer on RB1
void Play_Sound(){
  unsigned int buzz_count;

    for(buzz_count = 0; buzz_count < 1000; buzz_count++){                       // 1000 times 1 ms gives 1 second buzz
        Buzzer = 1;
        Delay_us(500);                                                          // adjust on/off times for preferred volume and frequency
        Buzzer = 0;
        Delay_us(500);                                                          // off for remainder of 1ms to give 1kHz
    }
}

// turn relays on
void relays_on(){
    Relay_1 = 1;
    Relay_2 = 1;
    Relay_3 = 1;
    Lcd_Out(1,1,Message3);                                                      // "Timer ON: HH:MM"
}

// set time to zero and stop counting
void time_zero(){

    leds_off();                                                                 // all LEDs off
    count_flag = 0;                                                             // stop the countdown
    fraction = 0;                                                               // set all time variables to zero
    seconds_units = 0;
    seconds_tens = 0;
    minutes_units = 0;
    minutes_tens = 0;
    hours = 0;
    zero_flag = 0;
    Relay_1 = 0;                                                                // RA0
    Relay_2 = 0;                                                                // RA1
    Relay_3 = 0;                                                                // RA2
    leds_off();                                                                 // all LEDs off
    Lcd_Out(1,1,Message2);                                                      // "Timer OFF     "
    Play_Sound();                                                               // activate the buzzer
    Lcd_Out(1,1,Message4);                                                      // "Set Time   "
    time_choice = 0;                                                            // 0 for no time selected
}

void main() {

    count_flag = 0;                                                             // no count down to start with
    ANSEL = 0x00;                                                               // all digital
    ANSELH = 0x00;                                                              // all digital
    CM1CON0 = 7;                                                                // Disable Comparators
    TRISA = 0b11001000;                                                         // TRISA
    TRISB = 0b00000000;                                                         // TRISB
    TRISC = 0b11001111;                                                         // TRISC
    Relay_1 = 0;                                                                // RA0
    Relay_2 = 0;                                                                // RA1
    Relay_3 = 0;                                                                // RA2
    Lcd_Init();                                                                 // Initialize LCD

    Lcd_Cmd(_LCD_CLEAR);                                                        // Clear LCD
    Lcd_Cmd(_LCD_CURSOR_OFF);                                                   // turn off flashing cursor
    Lcd_Out(1,1,Message1);                                                      // introducton text
    Delay_ms(3000);                                                             // allow time for intro text to be read by user
    Lcd_Out(1,1,Message2);                                                      // "Timer OFF"
    Delay_ms(2000);                                                             // allow time for intro text to be read by user
    Lcd_Out(2,1,Message5);                                                      // "Time Left: "
    OPTION_REG = 0x80 ;                                                         // bit7 Enable PORTB Pull UP

    time_zero();                                                                // set time to zero and stop counting

    InitTimer1();                                                               // start 100ms timer Interrupt running
    update_flag = 1;                                                            // show initial value
    
    while(1){                                                                   // main loop

        while(!update_flag){                                                    // wait for interrupt routine to indicate display update needed
            if(!Start_Stop_Button){                                             // and while waiting - check buttons
                if(count_flag){                                                 // are we counting?
                    time_zero();                                                // reset if counting
                }
                else{                                                           // not counting....
                    count_flag = 1;                                             // then start counting
                    led_RED = 1;                                                // RC5 red LED on while timer is counting down
                    relays_on();                                                // turn on all relays
                }
                debounce();                                                     // prevent multiple triggers
                while(!Start_Stop_Button);                                      // wait for button release
                update_flag = 1;                                                // show new value
            }
            if(!Min30_Button){                                                  // if RC1 goes low
                leds_off();                                                     // all lEDs off
                led_GREEN = 1;
                fraction = 0;
                seconds_units = 0;
                seconds_tens = 0;                                               // change to zero for final project
                minutes_units = 0;
                minutes_tens = 3;                                               // change to 3 for final project
                hours = 0;
                debounce();                                                     // prevent multiple triggers
                while(!Min30_Button);                                           // wait for button release
                update_flag = 1;                                                // show new value
                time_choice = 1;                                                // 1 for 30 minutes selected
            }
            if(!Hour2_Button){                                                  // if RC2 goes low
                leds_off();                                                     // all lEDs off
                led_YELLOW = 1;                                                 // RA5
                fraction = 0;
                seconds_units = 0;
                seconds_tens = 0;
                minutes_units = 0;
                minutes_tens = 0;
                hours = 2;
                debounce();                                                     // prevent multiple triggers
                while(!Hour2_Button);                                           // wait for button release
                update_flag = 1;                                                // show new value
                time_choice = 2;                                                // 2 for 2 hours selected
            }
            if(!Hour5_Button){                                                  // if RC2 goes low
                leds_off();                                                     // all lEDs off
                led_BLUE = 1;                                                   // RB0
                fraction = 0;
                seconds_units = 0;
                seconds_tens = 0;
                minutes_units = 0;
                minutes_tens = 0;
                hours = 5;
                debounce();                                                     // prevent multiple triggers
                while(!Hour5_Button);                                           // wait for button release
                update_flag = 1;                                                // show new value
                time_choice = 3;                                                // show that 5 hour selection was made
            }
            if(Oven_OFF){                                                       // if RC7 goes high
                time_zero();                                                    // set time to zero and stop counting
                update_flag = 1;                                                // show new value
                debounce();                                                     // prevent multiple triggers
            }
            if(zero_flag){                                                      // countdown just reached zero
                update_flag = 1;                                                // show new value
                time_zero();                                                    // set time to zero and stop counting
            }
            if(toggle_flag){                                                    // flash the colon on display
                Lcd_Chr(2,13,' ');
            }
            else{
                Lcd_Chr(2,13,':');
            }

}

            // next 2 lines are for DEBUG ONLY - delete or comment out on final project
        //    Lcd_Chr(1, 2, seconds_units + 48);                                 // print seconds
        //    Lcd_Chr(1, 1, seconds_tens + 48);

        Lcd_Chr(2, 15, minutes_units + 48);                                     // print minutes
        Lcd_Chr(2, 14, minutes_tens + 48);                                      // print minutes
        Lcd_Chr(2, 13, ':');                                                    // print colon
        Lcd_Chr(2, 12, hours + 48);                                             // print hours
        update_flag = 0;                                                        // prevent multiple printouts
    }
}